include Inject.inc

IDC_ENABLE		equ		1005
IDC_PACKETLIST	equ		1002
IDC_CLEAR		equ		1003
IDC_SAVE		equ		1004
PACKET_SIZE		equ		10240

.data?
	szPacket			db		PACKET_SIZE dup(?)
	szBuf				db		24 dup(?)
	hDialog				dd		?
	hFont				dd		?
	
LogPacket proto	:DWORD, :DWORD
LogConnect proto :DWORD, :DWORD
LogDisConnect proto :DWORD

include Hook.inc

.code	
LogConnect proc uses ecx _socket:DWORD, _sockaddr:DWORD
	invoke SendDlgItemMessage,hDialog,IDC_ENABLE,BM_GETCHECK,0,0
	cmp eax, BST_UNCHECKED
	je @F
	invoke lstrcpy,offset szPacket, CTEXT("SOCKET ")
	invoke wsprintf,offset szBuf,CTEXT("%X, "),_socket
	invoke lstrcat,offset szPacket,offset szBuf
	invoke lstrcat,offset szPacket,CTEXT("s ");
	mov eax, _sockaddr
	add eax, 4
	mov eax, [eax]
	invoke inet_ntoa,eax
	invoke lstrcat,offset szPacket,eax
	mov eax, _sockaddr
	add eax, 2
	movzx eax, word ptr [eax]
	mov cl, 16
	shl eax, cl
	bswap eax
	invoke wsprintf,offset szBuf, CTEXT(":%d."),eax
	invoke lstrcat,offset szPacket,offset szBuf
	invoke lstrlen,offset szPacket
	add eax, offset szPacket
	mov byte ptr [eax], 0dh
	mov byte ptr [eax+1], 0ah
	mov byte ptr [eax+2], 0h
	invoke GetDlgItem,hDialog,IDC_PACKETLIST
	push eax
	invoke SendMessage,eax,WM_GETTEXTLENGTH,0,0
	invoke SendMessage,[esp+0ch],EM_SETSEL,eax,eax
	invoke SendMessage,[esp+0ch],EM_REPLACESEL,FALSE,offset szPacket
	pop eax	 
@@:
	ret
LogConnect endp

LogDisConnect proc _socket:DWORD
	invoke SendDlgItemMessage,hDialog,IDC_ENABLE,BM_GETCHECK,0,0
	cmp eax, BST_UNCHECKED
	je @F
	invoke lstrcpy,offset szPacket,CTEXT("SOCKET ")
	invoke wsprintf,offset szBuf,CTEXT("%X "),_socket
	invoke lstrcat,offset szPacket,offset szBuf
	invoke lstrcat,offset szPacket,CTEXT(".");
	invoke GetDlgItem,hDialog,IDC_PACKETLIST
	push eax
	invoke SendMessage,eax,WM_GETTEXTLENGTH,0,0
	invoke SendMessage,[esp+0ch],EM_SETSEL,eax,eax
	invoke SendMessage,[esp+0ch],EM_REPLACESEL,FALSE,offset szPacket
	pop eax	 
@@:	
	ret
LogDisConnect endp

LogPacket proc uses ecx esi _lpszBuf:DWORD, _dwSize:DWORD	
	invoke SendDlgItemMessage,hDialog,IDC_ENABLE,BM_GETCHECK,0,0
	cmp eax, BST_UNCHECKED
	je @@exitLogPacket
	invoke wsprintf,offset szBuf, CTEXT("(%04d): "),_dwSize
	invoke lstrcat,offset szPacket,offset szBuf
	; _dwSize * 3 + 100
	mov eax, _dwSize
	mov ecx, 3
	xor edx, edx
	mul ecx
	add eax, 100
	.if eax > PACKET_SIZE
		invoke lstrcat,offset szPacket,CTEXT("Overflow!")
		jmp @@notConverPacket
	.endif	
	; buf length
	mov ecx, _dwSize
	mov esi, _lpszBuf
	; নQi
@@:
	movzx eax, byte ptr [esi]
	push ecx	
	invoke wsprintf,offset szBuf,CTEXT("%02X "),eax
	invoke lstrcat,offset szPacket, offset szBuf
	pop ecx
	dec ecx
	inc esi
	test ecx,ecx
	jne @B
@@notConverPacket:	
	invoke lstrlen,offset szPacket
	add eax, offset szPacket
	mov byte ptr [eax], 0dh
	mov byte ptr [eax+1], 0ah
	mov byte ptr [eax+2], 0
	invoke GetDlgItem,hDialog,IDC_PACKETLIST
	push eax
	invoke SendMessage,eax,WM_GETTEXTLENGTH,0,0
	invoke SendMessage,[esp+0ch],EM_SETSEL,eax,eax
	invoke SendMessage,[esp+0ch],EM_REPLACESEL,FALSE,offset szPacket
	pop eax
@@exitLogPacket:
	ret
LogPacket endp

SaveContext proc uses ecx hCon:DWORD
	local @lpBuf:DWORD, @dwSize:DWORD, @v:DWORD, @hFile:DWORD	
	
	invoke SendMessage,hCon,WM_GETTEXTLENGTH,0,0
	mov @dwSize, eax
	invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_READWRITE
	mov @lpBuf, eax
	invoke SendMessage,hCon,WM_GETTEXT,@dwSize,eax
	invoke CreateFile,CTEXT("C:\Packets.txt"),GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov @hFile, eax
	mov ecx, @dwSize
	dec ecx
	invoke WriteFile,@hFile,@lpBuf,ecx,addr @v,0
	invoke VirtualFree,@lpBuf,@dwSize,MEM_DECOMMIT
	invoke CloseHandle,@hFile
	ret
SaveContext endp

DlgProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	.if uMsg == WM_COMMAND
		.if wParam == IDC_CLEAR
			invoke SendDlgItemMessage,hWin,IDC_PACKETLIST,WM_SETTEXT,0,0
		.elseif wParam== IDC_SAVE
			invoke GetDlgItem,hWin,IDC_PACKETLIST
			invoke SaveContext, eax
		.endif
	.elseif uMsg == WM_CLOSE
		invoke MessageBox,hWin,CTEXT("zTwnʴܡH"),CTEXT("T"),MB_ICONINFORMATION or MB_YESNO
		.if eax == IDYES
			; index
			invoke DeleteObject,hFont
			mov ecx, 7
		@@:
			push ecx
			invoke RestoreAPI
			pop ecx
			dec ecx
			test ecx, ecx
			jnz @B
			invoke EndDialog,hWin,0
		.endif	
	.elseif uMsg == WM_INITDIALOG
		push hWin
		pop hDialog
		invoke CreateFont,12,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH or FF_SWISS,CTEXT("ө")
		mov hFont, eax
		invoke GetDlgItem,hWin,IDC_PACKETLIST
		push eax
		invoke SendMessage,eax,WM_SETFONT,hFont,TRUE
		pop eax
		invoke SendMessage,eax,WM_SETTEXT,0,0
		invoke SendDlgItemMessage,hWin,IDC_ENABLE,BM_SETCHECK,BST_CHECKED,0
		invoke InitInject,4
		invoke GetModuleHandle,CTEXT("ws2_32.dll")
		push eax
		invoke InjectAPI,eax,CTEXT('send'),offset mysend, TRUE
		invoke InjectAPI,[esp+0ch],CTEXT("WSASend"),myWSASend,TRUE
		invoke InjectAPI,[esp+0ch],CTEXT("recv"),myrecv,TRUE
		invoke InjectAPI,[esp+0ch],CTEXT("WSARecv"),myWSARecv,TRUE		
		invoke InjectAPI,[esp+0ch],CTEXT("connect"),myconnect,TRUE
		invoke InjectAPI,[esp+0ch],CTEXT("WSAConnect"),myWSAConnect,TRUE
		invoke InjectAPI,[esp+0ch],CTEXT("closesocket"),myclosesocket,TRUE
		pop eax
	.endif
	xor eax,eax
	ret
DlgProc endp
