APIINJECT	struct
	hModule		dword		?
	iStolen		dword		?
	fApi		byte		16 dup(?)
APIINJECT ends

.data?
	gApiBuffer		dd		?
	gApiBufferCount	dd		?
	gApiIndex		dd		?
	
include Catchy32.inc

.code
SetThread proc bState:DWORD
	local @pid, @tid: DWORD
	local @hsnap, @hthread: DWORD	
	local @te: THREADENTRY32
	
	invoke GetCurrentProcessId
	mov @pid, eax
	invoke GetCurrentThreadId
	mov @tid, eax
	
	invoke CreateToolhelp32Snapshot,TH32CS_SNAPTHREAD,0
	mov @hsnap, eax
	mov @te.dwSize, sizeof(THREADENTRY32)
	invoke Thread32First,@hsnap,addr @te
	.if eax == TRUE
	@@loopThread:
		mov eax, @te.th32OwnerProcessID
		cmp eax, @pid
		jne @F
		mov eax, @te.th32ThreadID
		cmp eax, @tid
		je @F
		invoke OpenThread,THREAD_SUSPEND_RESUME,FALSE,@te.th32ThreadID
		push eax
		.if bState == TRUE
			invoke ResumeThread,eax
		.else
			invoke SuspendThread,eax
		.endif
		pop eax
		invoke CloseHandle,eax
	@@:
		invoke Thread32Next,@hsnap,addr @te
		test eax,eax
		jnz @@loopThread
	.endif
	invoke CloseHandle,@hsnap
	ret
SetThread endp

InitInject proc apiCount: DWORD
	mov ecx, sizeof APIINJECT
	xor edx, edx
	mov eax, apiCount
	mul ecx
	mov gApiBufferCount, eax
	invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	mov gApiBuffer, eax
	mov gApiIndex, 0	
	ret
InitInject endp

InjectAPI proc uses ebx esi edi hmod:DWORD, szAPI:DWORD, fNewFunc:DWORD, bUseCall:DWORD
	local @mbi:MEMORY_BASIC_INFORMATION
	local @oldProtect:DWORD
	
	invoke GetProcAddress,hmod,szAPI
	push eax
	mov ebx, eax
	xor ecx, ecx
	; X instruction, Xj 5 bytes
@@:
	push ecx
	invoke c_Catchy,ebx
	pop ecx
	add ecx, eax
	add ebx, eax
	cmp ecx,5
	jb @B
	; N API }Yƥ 
	; esi  API }Y
	; edi ت buffer (APIINJECT)
	mov esi, [esp]
	mov eax, gApiIndex
	mov ebx, sizeof(APIINJECT) 
	xor edx,edx
	mul ebx
	add eax, gApiBuffer
	mov edi, eax	
	mov eax, [esp]
	mov dword ptr [edi], eax
	mov dword ptr [edi+4], ecx
	add edi, 8
@@:
	mov al, byte ptr [esi]
	mov byte ptr [edi], al
	inc edi
	inc esi
	dec ecx
	cmp ecx, 0
	ja @B
	; J JMP ^ API 
	mov byte ptr [edi], 0e9h
	mov dword ptr [edi+1], esi
	sub [edi+1], edi
	mov eax, 5	
	sub [edi+1], eax
	; N API }Y JMP  newfunc
	; ܧ Page v
	invoke VirtualQuery,[esp+8], addr @mbi, sizeof(MEMORY_BASIC_INFORMATION)
	invoke VirtualProtect,@mbi.BaseAddress,@mbi.RegionSize,PAGE_EXECUTE_READWRITE,addr @oldProtect
	.if bUseCall == 0
		mov al, 0e9h
	.else
		mov al, 0e8h
	.endif	
	mov edi, [esp]
	mov byte ptr [edi], al
	mov eax, fNewFunc
	mov [edi+1], eax
	mov eax, [esp]
	sub [edi+1], eax
	mov eax, 5
	sub [edi+1], eax
	pop eax
	invoke VirtualProtect,@mbi.BaseAddress,@mbi.RegionSize,@oldProtect,addr @oldProtect
	mov eax, gApiIndex
	inc gApiIndex
	ret
InjectAPI endp

RestoreAPI proc uses esi edi
	local @mbi: MEMORY_BASIC_INFORMATION
	local @oldProtect: DWORD
	
	dec gApiIndex
	mov eax, gApiIndex
	mov ecx, sizeof(APIINJECT)
	xor edx, edx
	mul ecx
	add eax, gApiBuffer
	; N Buffer mOU 
	push eax 
	mov ecx, [eax]
	invoke VirtualQuery,ecx,addr @mbi, sizeof(MEMORY_BASIC_INFORMATION)
	invoke VirtualProtect,@mbi.BaseAddress,@mbi.RegionSize,PAGE_EXECUTE_READWRITE,addr @oldProtect
	invoke SetThread, FALSE
	mov eax, [esp]
	mov ecx, [eax+4]
	mov esi, eax
	add esi, 8
	mov edi, [eax]
@@:
	mov al, byte ptr [esi]
	mov byte ptr [edi], al
	dec ecx
	inc esi
	inc edi
	test ecx,ecx
	jne @B
	pop eax
	invoke SetThread, TRUE
	invoke VirtualProtect,@mbi.BaseAddress,@mbi.RegionSize,@oldProtect,addr @oldProtect
	.if gApiIndex == 0
		invoke VirtualFree,gApiBuffer,gApiBufferCount,MEM_DECOMMIT
	.endif
@@exitRestore:
	ret
RestoreAPI endp

BackOriginalAPI:
	push ecx
	push edx
	mov ecx, sizeof(APIINJECT)
	xor edx, edx
	mul ecx
	add eax, gApiBuffer
	add eax, 8
	pop edx
	pop ecx
	jmp eax